#include <cv.h>
#include <highgui.h>
#include <stdio.h>
#include <stdio.h>

int main (int argc, char *argv[]) {
  float Max;
  int ans;
  int k;
  float p[3];
  int x, y;
          int fco = 0;
  IplImage *imgSrc = 0;
  IplImage *imgRef[10];
  IplImage *imgDiff[10];
  double min_value[10];
  double max_value[10];
  CvPoint min_loc[10];
  CvPoint max_loc[10];
  CvFont font;
  CvSize text_size;
  char file_name[256];
  char text[256];
  IplImage *imgGau;
          int one = 0;
          int i;
  
  if (argc < 2) {
    printf("Usage: numcheck imagename\n");
    return -1;
  }
  if((imgSrc = cvLoadImage(argv[1], CV_LOAD_IMAGE_COLOR)) == 0) {
    printf("Error: Failed to load %s\n", argv[1]);
    return -1;
  }
  
  if(strcmp(argv[1], "T1.jpg") == 0) one = 1;
  
  imgRef[0] = cvLoadImage("0.jpg", CV_LOAD_IMAGE_COLOR);
  imgRef[1] = cvLoadImage("1.jpg", CV_LOAD_IMAGE_COLOR);
  imgRef[2] = cvLoadImage("2.jpg", CV_LOAD_IMAGE_COLOR);
  imgRef[3] = cvLoadImage("3.jpg", CV_LOAD_IMAGE_COLOR);
  imgRef[4] = cvLoadImage("4.jpg", CV_LOAD_IMAGE_COLOR);
  imgRef[5] = cvLoadImage("5.jpg", CV_LOAD_IMAGE_COLOR);
  imgRef[6] = cvLoadImage("6.jpg", CV_LOAD_IMAGE_COLOR);
  imgRef[7] = cvLoadImage("7.jpg", CV_LOAD_IMAGE_COLOR);
  imgRef[8] = cvLoadImage("8.jpg", CV_LOAD_IMAGE_COLOR);
  imgRef[9] = cvLoadImage("9.jpg", CV_LOAD_IMAGE_COLOR);
  
  if(imgSrc == 0 || imgRef[1] == 0 || imgRef[2] == 0 || imgRef[3] == 0 || imgRef[4] == 0 || imgRef[5] == 0 || imgRef[6] == 0 || imgRef[7] == 0 || imgRef[8] == 0 || imgRef[9] == 0 || imgRef[0] == 0){
    return -1;
  }
  
  cvInitFont(&font, CV_FONT_HERSHEY_SIMPLEX, 2.0, 2.0, 0, 4, 4);
  
  for(i = 0; i < 10; i++) {
    imgDiff[i] = cvCreateImage(cvSize(imgSrc->width - imgRef[i]->width + 1, imgSrc->height - imgRef[i]->height + 1), 32, 1);
  }
  
  imgGau = cvCreateImage(cvGetSize(imgSrc), imgSrc->depth, imgSrc->nChannels);
  cvSmooth (imgSrc, imgGau, CV_GAUSSIAN, 11, 0, 0, 0);
  cvNamedWindow("num", CV_WINDOW_AUTOSIZE);
  
  for(i = 0; i < 10; i++) {
    cvMatchTemplate(imgGau, imgRef[i], imgDiff[i], 5);
    cvMinMaxLoc(imgDiff[i], min_value+i, max_value+i, min_loc+i, max_loc+i, NULL);
  
    printf("max_value = %f, max_loc = %d %d\n", max_value[i], max_loc[i].x, max_loc[i].y);
  }
  Max = 0;
  ans = 0;
  for(i = 0; i < 5; i++) {
    if(max_value[i] > Max) { Max = max_value[i]; ans = i; }
  }
  for(i = 5; i < 10; i++) {
    if(max_value[i] > Max && one == 0) { Max = max_value[i]; ans = i; }
  }
   
  for(i = 0; i < 10; i++) {
    cvRectangle(imgSrc, max_loc[i], cvPoint(max_loc[i].x + imgRef[i]->width, max_loc[i].y + imgRef[i]->height), CV_RGB(255, 0, 0), 1, 8, 0);
  }
  
  printf("ans = %d, Max = %f\n", ans, Max);
  
  while(1) {
    cvShowImage("num", imgGau);
    cvMoveWindow("num",150,100);
  
    if(cvWaitKey(1)>=0) {
      break;
    } else if(fco == 100) {
      break;
    } else {
      fco++;
    }
  }
  
  sprintf(text, "%d", ans);
  cvGetTextSize(text, &font, &text_size, 0);
  cvPutText(imgGau, text, cvPoint (10, text_size.height), &font, CV_RGB(255,0,0));
  
  while(1)
  {
    cvShowImage("num", imgGau);
    cvMoveWindow("num",150,100);
  
    if(cvWaitKey(1)>=0) {
      break;
    } else if(fco == 400) {
      break;
    } else {
      fco++;
    }
  }
  return ans;
}
