#include <stdio.h>
#include <cv.h>
#include <highgui.h>

int main (int argc, char *argv[]) {
    char windowNameScale[]="Scale"; 
    IplImage *image;
    IplImage *imgt1, *imgt2, *imgt3, *imgh1, *imgh2;
    int fco = 0;
  
  if (argc < 2) {
    printf("Usage: resizecut imagename\n");
    return -1;
  }
  if((image = cvLoadImage(argv[1], CV_LOAD_IMAGE_COLOR)) == 0) {
    printf("Error: Failed to load %s\n", argv[1]);
    return -1;
  }

    IplImage *scale_image=cvCreateImage( cvSize(600, 480), IPL_DEPTH_8U, 3);
    cvResize(image, scale_image, CV_INTER_LINEAR);
 
    cvNamedWindow(windowNameScale, CV_WINDOW_AUTOSIZE);    

         cvSetImageROI(scale_image, cvRect(165, 48, 105, 160));
         cvSaveImage("T1.jpg", scale_image, 0);
         cvResetImageROI(scale_image);

         cvSetImageROI(scale_image, cvRect(245, 48, 105, 160));
         cvSaveImage("T2.jpg", scale_image, 0);
         cvResetImageROI(scale_image);

         cvSetImageROI(scale_image, cvRect(355, 48, 105, 160));
         cvSaveImage("T3.jpg", scale_image, 0);
         cvResetImageROI(scale_image);

         cvSetImageROI(scale_image, cvRect(275, 215, 130, 180));
         cvSaveImage("H1.jpg", scale_image, 0);
         cvResetImageROI(scale_image);

         cvSetImageROI(scale_image, cvRect(380, 215, 130, 180));
         cvSaveImage("H2.jpg", scale_image, 0);
         cvResetImageROI(scale_image);

    while(1)
    {
        cvShowImage(windowNameScale, scale_image);
        cvMoveWindow(windowNameScale,0,0);
 
        if(cvWaitKey(1)>=0) {
            break;
        } else if(fco == 100) {
            cvSaveImage("RESIZE.jpg", scale_image, 0);
            break;
        } else {
            fco++;
        }
    }

    imgt1 = cvLoadImage("T1.jpg", CV_LOAD_IMAGE_COLOR);
    imgt2 = cvLoadImage("T2.jpg", CV_LOAD_IMAGE_COLOR);
    imgt3 = cvLoadImage("T3.jpg", CV_LOAD_IMAGE_COLOR);
    imgh1 = cvLoadImage("H1.jpg", CV_LOAD_IMAGE_COLOR);
    imgh2 = cvLoadImage("H2.jpg", CV_LOAD_IMAGE_COLOR);

    cvNamedWindow("T1", CV_WINDOW_AUTOSIZE);
    cvNamedWindow("T2", CV_WINDOW_AUTOSIZE);
    cvNamedWindow("T3", CV_WINDOW_AUTOSIZE);
    cvNamedWindow("H1", CV_WINDOW_AUTOSIZE);
    cvNamedWindow("H2", CV_WINDOW_AUTOSIZE);

    fco = 0;
    while(1)
    {
        cvShowImage("T1", imgt1);
        cvMoveWindow("T1",0,420);
        cvShowImage("T2", imgt2);
        cvMoveWindow("T2",120,420);
        cvShowImage("T3", imgt3);
        cvMoveWindow("T3",240,420);
        cvShowImage("H1", imgh1);
        cvMoveWindow("H1",360,420);
        cvShowImage("H2", imgh2);
        cvMoveWindow("H2",480,420);
 
        if(cvWaitKey(1)>=0) {
            break;
        } else if(fco == 500) {
            break;
        } else {
            fco++;
        }
    }

    cvReleaseImage(&scale_image);
    cvReleaseImage(&imgt1);
    cvReleaseImage(&imgt2);
    cvReleaseImage(&imgt3);
    cvReleaseImage(&imgh1);
    cvReleaseImage(&imgh2);
    cvDestroyWindow(windowNameScale);    
    cvDestroyWindow("T1");    
    cvDestroyWindow("T2");    
    cvDestroyWindow("T3");    
    cvDestroyWindow("H1");    
    cvDestroyWindow("H2");    
 
    return 0;
}
