#include <stdio.h>
#include <highgui.h>

int main(int argc, char *argv[])
{
    int fco = 0;
    CvCapture *capture = NULL;  
    IplImage*  img;
    char winNameCapture[] = "camcapture";
    char *fname = "camonoff.txt";
    char savefile[20];
    int CAMN;
    int i;

    if(argc != 2) {
      fprintf(stderr, "Usage: %s CamNumber\r\n", argv[0]);
      return -1;
    }

    CAMN = atoi(argv[1]);
    sprintf( savefile, "CAM%s.jpg", argv[1]);
    printf( "%s\n", savefile );

    capture=cvCreateCameraCapture(CAMN);   
    if(capture==NULL)
    {                          
        fprintf(stderr, "can not find a camera!! \n");
        return -1;
    }

    cvNamedWindow(winNameCapture, CV_WINDOW_AUTOSIZE);

    while(1)
    {
        img=cvQueryFrame(capture);   
        cvShowImage(winNameCapture, img);  

        if(cvWaitKey(1)>=0) {
            break;
        } else if(fco == 30) {
            cvSaveImage(savefile, img, 0);  
            break;
        } else {
            fco++;
        }
    }
    cvDestroyWindow(winNameCapture);    
    cvReleaseCapture(&capture);          

    return 0;
}

